diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileClient.java b/base/common/src/com/netscape/certsrv/profile/ProfileClient.java
new file mode 100644
index 0000000000000000000000000000000000000000..12b54cc60a1954ed8d88cf1b5399dd8e16a56e57
--- /dev/null
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileClient.java
@@ -0,0 +1,73 @@
+//--- BEGIN COPYRIGHT BLOCK ---
+//This program is free software; you can redistribute it and/or modify
+//it under the terms of the GNU General Public License as published by
+//the Free Software Foundation; version 2 of the License.
+//
+//This program is distributed in the hope that it will be useful,
+//but WITHOUT ANY WARRANTY; without even the implied warranty of
+//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//GNU General Public License for more details.
+//
+//You should have received a copy of the GNU General Public License along
+//with this program; if not, write to the Free Software Foundation, Inc.,
+//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+//(C) 2012 Red Hat, Inc.
+//All rights reserved.
+//--- END COPYRIGHT BLOCK ---
+package com.netscape.certsrv.profile;
+
+import java.net.URISyntaxException;
+
+import com.netscape.certsrv.client.ClientConfig;
+import com.netscape.certsrv.client.PKIClient;
+
+/**
+ * @author Ade Lee
+ */
+public class ProfileClient {
+    public PKIClient client;
+    public ProfileResource profileClient;
+
+    public ProfileClient(ClientConfig config) throws URISyntaxException {
+        this(new PKIClient(config));
+    }
+
+    public ProfileClient(PKIClient client) throws URISyntaxException {
+        this.client = client;
+        init();
+    }
+
+    public void init() throws URISyntaxException {
+        profileClient = client.createProxy(ProfileResource.class);
+    }
+
+    public ProfileData retrieveProfile(String id) {
+        return profileClient.retrieveProfile(id);
+    }
+
+    public ProfileDataInfos listProfiles() {
+        return profileClient.listProfiles();
+    }
+
+    public void enableProfile(String id) {
+        profileClient.modifyProfileState(id, "enable");
+    }
+
+    public void disableProfile(String id) {
+        profileClient.modifyProfileState(id, "disable");
+    }
+
+    public void createProfile(ProfileData data){
+        profileClient.createProfile(data);
+    }
+
+    public void modifyProfile(ProfileData data){
+        profileClient.modifyProfile(data.getId(), data);
+    }
+
+    public void deleteProfile(String id) {
+        profileClient.deleteProfile(id);
+    }
+
+}
diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileData.java b/base/common/src/com/netscape/certsrv/profile/ProfileData.java
index 465981add8bc81c2f77051e031a83234aaf54179..a8bb11031d6801dc5a86ff0c23c6948822aef964 100644
--- a/base/common/src/com/netscape/certsrv/profile/ProfileData.java
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileData.java
@@ -22,13 +22,17 @@
 package com.netscape.certsrv.profile;
 
 import java.util.ArrayList;
-import java.util.Iterator;
+import java.util.LinkedHashMap;
 import java.util.List;
+import java.util.Map;
+import java.util.Vector;
 
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
 import javax.xml.bind.annotation.XmlRootElement;
+import javax.xml.bind.annotation.adapters.XmlAdapter;
+import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
 
 /**
  * @author jmagne
@@ -43,22 +47,79 @@ public class ProfileData {
     protected String id;
 
     @XmlElement
+    protected String classId;
+
+    @XmlElement
     protected String name;
 
     @XmlElement
     protected String description;
 
     @XmlElement
-    protected boolean isEnabled;
+    protected boolean enabled;
 
     @XmlElement
-    protected boolean isVisible;
+    protected boolean visible;
 
     @XmlElement
     protected String enabledBy;
 
-    @XmlElement(name = "Input")
-    protected List<ProfileInput> inputs = new ArrayList<ProfileInput>();
+    @XmlElement
+    protected String authenticatorId;
+
+    @XmlElement
+    protected String authzAcl;
+
+    @XmlElement
+    protected boolean renewal;
+
+    @XmlElement
+    protected boolean isXMLOutput;
+
+    @XmlElement(name = "Inputs")
+    @XmlJavaTypeAdapter(InputAdapter.class)
+    protected Map<String, ProfileInput> inputs = new LinkedHashMap<String, ProfileInput>();
+
+    @XmlElement(name = "Outputs")
+    @XmlJavaTypeAdapter(OutputAdapter.class)
+    protected Map<String, ProfileOutput> outputs = new LinkedHashMap<String, ProfileOutput>();
+
+    @XmlElement(name = "PolicySets")
+    @XmlJavaTypeAdapter(PolicySetAdapter.class)
+    protected Map<String, List<ProfilePolicy>> policySets = new LinkedHashMap<String, List<ProfilePolicy>>();
+
+
+    public String getAuthenticatorId() {
+        return authenticatorId;
+    }
+
+    public void setAuthenticatorId(String authenticatorId) {
+        this.authenticatorId = authenticatorId;
+    }
+
+    public String getAuthzAcl() {
+        return authzAcl;
+    }
+
+    public void setAuthzAcl(String authzAcl) {
+        this.authzAcl = authzAcl;
+    }
+
+    public boolean isRenewal() {
+        return  renewal;
+    }
+
+    public void setRenewal(boolean renewal) {
+        this.renewal = renewal;
+    }
+
+    public boolean isXMLOutput() {
+        return isXMLOutput;
+    }
+
+    public void setXMLOutput(boolean isXMLOutput) {
+        this.isXMLOutput = isXMLOutput;
+    }
 
     public void setName(String name) {
         this.name = name;
@@ -76,20 +137,20 @@ public class ProfileData {
         return description;
     }
 
-    public void setIsEnabled(boolean isEnabled) {
-        this.isEnabled = isEnabled;
+    public void setEnabled(boolean enabled) {
+        this.enabled = enabled;
     }
 
-    public boolean getIsEnabled() {
-        return isEnabled;
+    public boolean isEnabled() {
+        return enabled;
     }
 
-    public void setIsVisible(boolean isVisible) {
-        this.isVisible = isVisible;
+    public void setVisible(boolean visible) {
+        this.visible = visible;
     }
 
-    public boolean getIsVisible() {
-        return isVisible;
+    public boolean isVisible() {
+        return visible;
     }
 
     public void setEnabledBy(String enabledBy) {
@@ -108,40 +169,188 @@ public class ProfileData {
         return id;
     }
 
-    public ProfileInput addProfileInput(String name) {
-
-        ProfileInput oldInput = getProfileInput(name);
-
-        if (oldInput != null)
-            return oldInput;
-
-        ProfileInput newInput = new ProfileInput();
-        newInput.setInputId(name);
-
-        inputs.add(newInput);
-
-        return newInput;
+    public String getClassId() {
+        return classId;
     }
 
-    public ProfileInput getProfileInput(String name) {
-
-        ProfileInput input = null;
-
-        Iterator<ProfileInput> it = inputs.iterator();
-
-        ProfileInput curInput = null;
-        while (it.hasNext()) {
-            curInput = it.next();
+    public void setClassId(String classId) {
+        this.classId = classId;
+    }
 
-            if (curInput != null && curInput.getInputId().equals(name))
-                break;
-        }
+    public void addProfileInput(String id, ProfileInput input) {
+        inputs.put(id, input);
+    }
 
-        return input;
+    public ProfileInput getProfileInput(String id) {
+        return inputs.get(id);
     }
 
-    public List<ProfileInput> getProfileInputsList() {
+    public Map<String, ProfileInput> getInputs() {
         return inputs;
     }
 
+    public void setInputs(Map<String, ProfileInput> inputs) {
+        this.inputs = inputs;
+    }
+
+    public Map<String, ProfileOutput> getOutputs() {
+        return outputs;
+    }
+
+    public void setOutputs(Map<String, ProfileOutput> outputs) {
+        this.outputs = outputs;
+    }
+
+    public Map<String, List<ProfilePolicy>> getPolicySets() {
+        return policySets;
+    }
+
+    public void setPolicySets(Map<String, List<ProfilePolicy>> policySets) {
+        this.policySets = policySets;
+    }
+
+    public void addProfilePolicySet(String id, Vector<ProfilePolicy> policySet) {
+        this.policySets.put(id, policySet);
+    }
+
+    public void addProfileOutput(String id, ProfileOutput output) {
+        outputs.put(id, output);
+    }
+
+    public ProfileOutput getProfileOutput(String id) {
+        return outputs.get(id);
+    }
+
+    public static class InputAdapter extends XmlAdapter<InputList, Map<String, ProfileInput>> {
+
+        public InputList marshal(Map<String,ProfileInput> map) {
+            InputList list = new InputList();
+            for (Map.Entry<String, ProfileInput> entry : map.entrySet()) {
+                Input input = new Input();
+                input.name = entry.getKey();
+                input.value = entry.getValue();
+                list.inputs.add(input);
+            }
+            return list;
+        }
+
+        public Map<String, ProfileInput> unmarshal(InputList list) {
+            Map<String, ProfileInput> map = new LinkedHashMap<String, ProfileInput>();
+            for (Input input : list.inputs) {
+                map.put(input.name, input.value);
+            }
+            return map;
+        }
+    }
+
+    public static class InputList {
+        @XmlElement(name="input")
+        public List<Input> inputs = new ArrayList<Input>();
+    }
+
+    public static class Input {
+
+        @XmlElement(name="id")
+        public String name;
+
+        @XmlElement
+        public ProfileInput value;
+    }
+
+    public static class OutputAdapter extends XmlAdapter<OutputList, Map<String, ProfileOutput>> {
+
+        public OutputList marshal(Map<String,ProfileOutput> map) {
+            OutputList list = new OutputList();
+            for (Map.Entry<String, ProfileOutput> entry : map.entrySet()) {
+                Output output = new Output();
+                output.name = entry.getKey();
+                output.value = entry.getValue();
+                list.outputs.add(output);
+            }
+            return list;
+        }
+
+        public Map<String, ProfileOutput> unmarshal(OutputList list) {
+            Map<String, ProfileOutput> map = new LinkedHashMap<String, ProfileOutput>();
+            for (Output output : list.outputs) {
+                map.put(output.name, output.value);
+            }
+            return map;
+        }
+    }
+
+    public static class OutputList {
+        @XmlElement(name="output")
+        public List<Output> outputs = new ArrayList<Output>();
+    }
+
+    public static class Output {
+
+        @XmlElement(name="id")
+        public String name;
+
+        @XmlElement
+        public ProfileOutput value;
+    }
+
+    public static class PolicySetAdapter extends XmlAdapter<PolicySetList, Map<String, Vector<ProfilePolicy>>> {
+
+        public PolicySetList marshal(Map<String,Vector<ProfilePolicy>> map) {
+            PolicySetList list = new PolicySetList();
+            for (Map.Entry<String, Vector<ProfilePolicy>> entry : map.entrySet()) {
+                PolicySet pset = new PolicySet();
+                pset.name = entry.getKey();
+                pset.value = entry.getValue();
+                list.psets.add(pset);
+            }
+            return list;
+        }
+
+        public Map<String, Vector<ProfilePolicy>> unmarshal(PolicySetList list) {
+            Map<String, Vector<ProfilePolicy>> map = new LinkedHashMap<String, Vector<ProfilePolicy>>();
+            for (PolicySet pset : list.psets) {
+                map.put(pset.name, pset.value);
+            }
+            return map;
+        }
+    }
+
+    public static class PolicySetList {
+        @XmlElement(name="PolicySet")
+        public List<PolicySet> psets = new ArrayList<PolicySet>();
+    }
+
+    public static class PolicySet {
+
+        @XmlElement(name="id")
+        public String name;
+
+        @XmlElement
+        public Vector<ProfilePolicy> value;
+    }
+
+    public static void main(String args[]) throws Exception {
+        Map<String, ProfileInput> inputs = new LinkedHashMap<String, ProfileInput>();
+        //ProfileInput input = new ProfileInput();
+        //input.setClassId(classId);
+        //input.setInputId(inputId);
+        //input.setName(name);
+        //input.setText(text);
+
+
+        ProfileData data = new ProfileData();
+        data.setClassId("com.netscape.cms.profile.common.CAEnrollProfile");
+        data.setDescription("This certificate profile is for enrolling user certificates.");
+        data.setEnabled(true);
+        data.setEnabledBy("admin");
+        data.setId("caUserCertEnrollImpl");
+        data.setInputs(inputs);
+        data.setName("Manual User Dual-Use Certificate Enrollment");
+        //data.setOutputs(outputs);
+        //data.setPolicySets(policySets);
+        data.setRenewal(false);
+        data.setVisible(true);
+        data.setXMLOutput(false);
+    }
+
 }
\ No newline at end of file
diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileInput.java b/base/common/src/com/netscape/certsrv/profile/ProfileInput.java
index 64d2aafdbbdd22136f39740df088d70ad566af4a..3a3aefe4c136a15f2aadbace4ae64c0e00812655 100644
--- a/base/common/src/com/netscape/certsrv/profile/ProfileInput.java
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileInput.java
@@ -18,77 +18,104 @@
 package com.netscape.certsrv.profile;
 
 import java.util.ArrayList;
-import java.util.LinkedHashMap;
+import java.util.Enumeration;
 import java.util.List;
-import java.util.Map;
+import java.util.Locale;
 
-import javax.xml.bind.annotation.XmlAttribute;
 import javax.xml.bind.annotation.XmlElement;
-import javax.xml.bind.annotation.XmlValue;
-import javax.xml.bind.annotation.adapters.XmlAdapter;
-import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
+
+import com.netscape.certsrv.property.Descriptor;
 
 public class ProfileInput {
 
+    private String classId;
+    private String name;
+    private String text;
+    private List<ProfileAttribute> attrs = new ArrayList<ProfileAttribute>();
+    private List<ProfileAttribute> configAttrs = new ArrayList<ProfileAttribute>();
+
     public ProfileInput() {
         // required for jaxb
     }
 
+    public ProfileInput(IProfileInput input, String classId, Locale locale) {
+        this.name = input.getName(locale);
+        this.classId = classId;
+        Enumeration<String> names = input.getValueNames();
+        while (names.hasMoreElements()) {
+            String name = names.nextElement();
+            addAttribute(new ProfileAttribute(name, null,
+                    (Descriptor) input.getValueDescriptor(locale, name)));
+        }
+    }
+
     @XmlElement
-    public String getInputId() {
-        return inputId;
+    public String getClassId() {
+        return classId;
     }
 
-    private String inputId;
+    @XmlElement
+    public String getName() {
+        return name;
+    }
 
-    @XmlJavaTypeAdapter(InputAttrsAdapter.class)
-    public Map<String, String> InputAttrs = new LinkedHashMap<String, String>();
+    @XmlElement
+    public String getText() {
+        return text;
+    }
 
-    public void setInputAttr(String name, String value) {
-        InputAttrs.put(name, value);
+    public void setClassId(String classId) {
+        this.classId = classId;
     }
 
-    public void setInputId(String inputId) {
-        this.inputId = inputId;
+    public void setName(String name) {
+        this.name = name;
     }
 
-    public static class InputAttrsAdapter extends XmlAdapter<InputAttrList, Map<String, String>> {
+    public void setText(String text) {
+        this.text = text;
+    }
 
-        public InputAttrList marshal(Map<String, String> map) {
-            InputAttrList list = new InputAttrList();
-            for (Map.Entry<String, String> entry : map.entrySet()) {
-                Attribute attribute = new Attribute();
-                attribute.name = entry.getKey();
-                attribute.value = entry.getValue();
-                list.attributes.add(attribute);
-            }
-            return list;
-        }
+    @XmlElement(name = "attribute")
+    public List<ProfileAttribute> getAttrs() {
+        return attrs;
+    }
 
-        public Map<String, String> unmarshal(InputAttrList list) {
-            Map<String, String> map = new LinkedHashMap<String, String>();
-            for (Attribute attribute : list.attributes) {
-                map.put(attribute.name, attribute.value);
-            }
-            return map;
-        }
+    public void setAttrs(List<ProfileAttribute> attrs) {
+        this.attrs = attrs;
+    }
+
+    public void addAttribute(ProfileAttribute attr) {
+        attrs.add(attr);
+    }
+
+    public void removeAttribute(ProfileAttribute attr) {
+        attrs.remove(attr);
     }
 
-    public static class InputAttrList {
-        @XmlElement(name = "InputAttr")
-        public List<Attribute> attributes = new ArrayList<Attribute>();
+    public void clearAttributes() {
+        attrs.clear();
     }
 
-    public static class Attribute {
+    @XmlElement(name = "config_attribute")
+    public List<ProfileAttribute> getConfigAttrs() {
+        return configAttrs;
+    }
 
-        @XmlAttribute
-        public String name;
+    public void setConfigAttrs(List<ProfileAttribute> configAttrs) {
+        this.configAttrs = configAttrs;
+    }
 
-        @XmlValue
-        public String value;
+    public void addConfigAttribute(ProfileAttribute configAttr) {
+        attrs.add(configAttr);
     }
 
-    public Map<String, String> getAttributes() {
-        return InputAttrs;
+    public void removeConfigAttribute(ProfileAttribute configAttr) {
+        attrs.remove(configAttr);
     }
+
+    public void clearConfigAttributes() {
+        configAttrs.clear();
+    }
+
 }
diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileOutput.java b/base/common/src/com/netscape/certsrv/profile/ProfileOutput.java
index 2e25f619d2f2860fe493dc595b81497309ab608a..492fdb46a4b0de2a92d7dbe7e8fca2488f0b689e 100644
--- a/base/common/src/com/netscape/certsrv/profile/ProfileOutput.java
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileOutput.java
@@ -18,39 +18,55 @@
 package com.netscape.certsrv.profile;
 
 import java.util.ArrayList;
+import java.util.Enumeration;
 import java.util.List;
+import java.util.Locale;
 
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
 import javax.xml.bind.annotation.XmlRootElement;
 
+import com.netscape.certsrv.property.Descriptor;
+
 @XmlRootElement
 @XmlAccessorType(XmlAccessType.FIELD)
 public class ProfileOutput {
 
-    public ProfileOutput() {
-        // required for jaxb
-    }
-
-    @XmlElement
-    private String outputId;
-
-    @XmlElement(name = "attributes")
-    private List<ProfileAttribute> attrs = new ArrayList<ProfileAttribute>();
-
     @XmlElement
     private String name;
 
     @XmlElement
     private String text;
 
-    public String getOutputId() {
-        return outputId;
+    @XmlElement
+    private String classId;
+
+    @XmlElement(name = "attributes")
+    private List<ProfileAttribute> attrs = new ArrayList<ProfileAttribute>();
+
+
+    public ProfileOutput() {
+        // required for jaxb
+    }
+
+    public ProfileOutput(IProfileOutput output, String classId, Locale locale) {
+        this.name = output.getName(locale);
+        this.classId = classId;
+        Enumeration<String> names = output.getValueNames();
+        while (names.hasMoreElements()) {
+            String name = names.nextElement();
+            addAttribute(new ProfileAttribute(name, null,
+                    (Descriptor) output.getValueDescriptor(locale, name)));
+        }
+    }
+
+    public String getClassId() {
+        return classId;
     }
 
-    public void setOutputId(String OutputId) {
-        this.outputId = OutputId;
+    public void setClassId(String classId) {
+        this.classId = classId;
     }
 
     public List<ProfileAttribute> getAttrs() {
@@ -81,4 +97,12 @@ public class ProfileOutput {
         attrs.add(attr);
     }
 
+    public void removeAttribute(ProfileAttribute attr) {
+        attrs.remove(attr);
+    }
+
+    public void clearAttributes() {
+        attrs.clear();
+    }
+
 }
diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileParameter.java b/base/common/src/com/netscape/certsrv/profile/ProfileParameter.java
new file mode 100644
index 0000000000000000000000000000000000000000..f137d87ecc9a990079f9d4fb9e03078216974e43
--- /dev/null
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileParameter.java
@@ -0,0 +1,66 @@
+//--- BEGIN COPYRIGHT BLOCK ---
+//This program is free software; you can redistribute it and/or modify
+//it under the terms of the GNU General Public License as published by
+//the Free Software Foundation; version 2 of the License.
+//
+//This program is distributed in the hope that it will be useful,
+//but WITHOUT ANY WARRANTY; without even the implied warranty of
+//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//GNU General Public License for more details.
+//
+//You should have received a copy of the GNU General Public License along
+//with this program; if not, write to the Free Software Foundation, Inc.,
+//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+//
+//(C) 2012 Red Hat, Inc.
+//All rights reserved.
+//--- END COPYRIGHT BLOCK ---
+package com.netscape.certsrv.profile;
+
+import javax.xml.bind.annotation.XmlAccessType;
+import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlAttribute;
+import javax.xml.bind.annotation.XmlElement;
+import javax.xml.bind.annotation.XmlRootElement;
+
+@XmlRootElement
+@XmlAccessorType(XmlAccessType.FIELD)
+public class ProfileParameter {
+
+ @XmlAttribute
+ private String name;
+
+ @XmlElement
+ private String value;
+
+ public ProfileParameter() {
+     // required for jax-b
+ }
+
+ public ProfileParameter(String name, String value) {
+     this.name = name;
+     this.value = value;
+ }
+
+ public String getName() {
+     return name;
+ }
+
+ public void setName(String name) {
+     this.name = name;
+ }
+
+ public String getValue() {
+     return value;
+ }
+
+ public void setValue(String value) {
+     this.value = value;
+ }
+
+ @Override
+ public String toString() {
+     return "ProfileParameter [name=" + name + ", value=" + value + "]";
+ }
+
+}
\ No newline at end of file
diff --git a/base/common/src/com/netscape/certsrv/profile/ProfileResource.java b/base/common/src/com/netscape/certsrv/profile/ProfileResource.java
index 572e6eb8844dca6f77e764fed7b7826d132bcbf0..317215afb943d76819cce7073ae2261743d597fd 100644
--- a/base/common/src/com/netscape/certsrv/profile/ProfileResource.java
+++ b/base/common/src/com/netscape/certsrv/profile/ProfileResource.java
@@ -1,46 +1,55 @@
 package com.netscape.certsrv.profile;
 
+import javax.ws.rs.Consumes;
+import javax.ws.rs.DELETE;
 import javax.ws.rs.GET;
+import javax.ws.rs.POST;
+import javax.ws.rs.PUT;
 import javax.ws.rs.Path;
 import javax.ws.rs.PathParam;
 import javax.ws.rs.Produces;
+import javax.ws.rs.QueryParam;
 import javax.ws.rs.core.MediaType;
 
 import com.netscape.certsrv.authentication.AuthMethodMapping;
 
-
-@Path("agent/profiles")
-@AuthMethodMapping("agent")
+@Path("")
 public interface ProfileResource {
 
     @GET
-    @Path("{id}")
-    @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
-    public ProfileData retrieveProfile(@PathParam("id") String id);
-
-    @GET
+    @Path("profiles")
     @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
     public ProfileDataInfos listProfiles();
 
-    /**
-     * Used to retrieve a key
-     *
-     * @param data
-     * @return
-     */
+    @GET
+    @Path("profiles/{id}")
+    @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public ProfileData retrieveProfile(@PathParam("id") String id);
 
-    /*
     @POST
-    @Path("retrieve")
+    @Path("admin/profiles")
+    @AuthMethodMapping("admin")
     @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
     @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
-    public ProfileData retrieveProfile(ProfileRetrievalRequestData request);
+    public void createProfile(ProfileData data);
 
-    // retrieval - used to test integration with a browser
     @POST
-    @Path("retrieve")
+    @Path("agent/profiles/{id}")
+    @AuthMethodMapping("agent")
+    @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void modifyProfileState(@PathParam("id") String id, @QueryParam("action") String action);
+
+    @PUT
+    @Path("admin/profiles/{id}")
+    @AuthMethodMapping("admin")
     @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
-    @Consumes({ MediaType.APPLICATION_FORM_URLENCODED })
-    public ProfileData retrievProfile(MultivaluedMap<String, String> form);
-    */
+    @Consumes({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void modifyProfile(@PathParam("id") String id, ProfileData data);
+
+    @DELETE
+    @Path("admin/profiles/{id}")
+    @AuthMethodMapping("admin")
+    @Produces({ MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON })
+    public void deleteProfile(@PathParam("id") String id);
+
 }
\ No newline at end of file
diff --git a/base/common/src/com/netscape/certsrv/property/Descriptor.java b/base/common/src/com/netscape/certsrv/property/Descriptor.java
index d3048e0b9b8be0371044d9c208dce3f06cb8767d..f5069d0461479b9e27e4d30e87f8c5ea43daff0d 100644
--- a/base/common/src/com/netscape/certsrv/property/Descriptor.java
+++ b/base/common/src/com/netscape/certsrv/property/Descriptor.java
@@ -21,6 +21,7 @@ import java.util.Locale;
 
 import javax.xml.bind.annotation.XmlAccessType;
 import javax.xml.bind.annotation.XmlAccessorType;
+import javax.xml.bind.annotation.XmlElement;
 import javax.xml.bind.annotation.XmlRootElement;
 
 
@@ -34,9 +35,16 @@ import javax.xml.bind.annotation.XmlRootElement;
 @XmlAccessorType(XmlAccessType.FIELD)
 public class Descriptor implements IDescriptor {
 
+    @XmlElement(name = "syntax")
     protected String mSyntax = null;
+
+    @XmlElement(name = "constraint")
     protected String mConstraint = null;
+
+    @XmlElement(name = "description")
     protected String mDescription = null;
+
+    @XmlElement(name = "defaultValue")
     protected String mDef = null;
 
     public Descriptor() {
diff --git a/base/common/src/com/netscape/cms/profile/common/BasicProfile.java b/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
index 0c60f081c0e4fd68019397c3af6dc38fe30adf52..c3f6b327deb49ee10597678887bc8bffd94ff4e5 100644
--- a/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
+++ b/base/common/src/com/netscape/cms/profile/common/BasicProfile.java
@@ -20,6 +20,7 @@ package com.netscape.cms.profile.common;
 import java.util.Enumeration;
 import java.util.Hashtable;
 import java.util.Locale;
+import java.util.Map;
 import java.util.StringTokenizer;
 import java.util.Vector;
 
@@ -116,6 +117,10 @@ public abstract class BasicProfile implements IProfile {
         }
     }
 
+    public void setRenewal(boolean renewal) {
+        mConfig.putBoolean(PROP_IS_RENEWAL, renewal);
+    }
+
     public String isXmlOutput() {
         try {
             return mConfig.getString(PROP_XML_OUTPUT, "false");
@@ -124,6 +129,10 @@ public abstract class BasicProfile implements IProfile {
         }
     }
 
+    public void setXMLOutput(boolean xmlOutput) {
+        mConfig.putBoolean(PROP_XML_OUTPUT, xmlOutput);
+    }
+
     public String getApprovedBy() {
         try {
             return mConfig.getString(PROP_ENABLE_BY, "");
@@ -175,6 +184,11 @@ public abstract class BasicProfile implements IProfile {
         mConfig.putString("auth." + PROP_INSTANCE_ID, id);
     }
 
+    public void setAuthzAcl(String id) {
+        mAuthzAcl = id;
+        mConfig.putString("authz.acl", id);
+    }
+
     public String getAuthzAcl() {
         return mAuthzAcl;
     }
@@ -459,6 +473,18 @@ public abstract class BasicProfile implements IProfile {
 
     }
 
+    public void deleteAllProfilePolicies() throws EProfileException {
+        for (Map.Entry<String, Vector<ProfilePolicy>> entry : mPolicySet.entrySet()) {
+            String setId = entry.getKey();
+            Vector<ProfilePolicy> pList = new Vector<ProfilePolicy>(entry.getValue());
+            for (ProfilePolicy policy: pList) {
+                deleteProfilePolicy(setId, policy.getId());
+            }
+        }
+
+        mPolicySet.clear();
+    }
+
     public void deleteProfileInput(String inputId) throws EProfileException {
         try {
             mConfig.removeSubStore("input." + inputId);
@@ -499,6 +525,14 @@ public abstract class BasicProfile implements IProfile {
         }
     }
 
+    public void deleteAllProfileInputs() throws EProfileException {
+        // need to use a copy here because we are removing elements from the vector
+        Vector<String> inputs = new Vector<String>(mInputIds);
+        for (String id: inputs) {
+            deleteProfileInput(id);
+        }
+    }
+
     public void deleteProfileOutput(String outputId) throws EProfileException {
         try {
             mConfig.removeSubStore("output." + outputId);
@@ -539,6 +573,14 @@ public abstract class BasicProfile implements IProfile {
         }
     }
 
+    public void deleteAllProfileOutputs() throws EProfileException {
+     // need to use a copy here because we are removing elements from the vector
+        Vector<String> outputs = new Vector<String>(mOutputIds);
+        for (String id: outputs) {
+            deleteProfileOutput(id);
+        }
+    }
+
     public IProfileOutput createProfileOutput(String id, String outputId,
             NameValuePairs nvps)
             throws EProfileException {
diff --git a/base/common/src/com/netscape/cms/servlet/cert/CertProcessor.java b/base/common/src/com/netscape/cms/servlet/cert/CertProcessor.java
index 52326a512b6e1817eede10a7873011bd12227553..8ffa65d9b4f1a8e0e8f8b898fc570d42adb97a78 100644
--- a/base/common/src/com/netscape/cms/servlet/cert/CertProcessor.java
+++ b/base/common/src/com/netscape/cms/servlet/cert/CertProcessor.java
@@ -22,7 +22,6 @@ import java.util.Date;
 import java.util.Enumeration;
 import java.util.HashMap;
 import java.util.Locale;
-import java.util.Map;
 
 import javax.servlet.http.HttpServletRequest;
 
@@ -38,6 +37,7 @@ import com.netscape.certsrv.profile.IProfile;
 import com.netscape.certsrv.profile.IProfileAuthenticator;
 import com.netscape.certsrv.profile.IProfileContext;
 import com.netscape.certsrv.profile.IProfileInput;
+import com.netscape.certsrv.profile.ProfileAttribute;
 import com.netscape.certsrv.profile.ProfileInput;
 import com.netscape.certsrv.request.INotify;
 import com.netscape.certsrv.request.IRequest;
@@ -78,9 +78,8 @@ public class CertProcessor extends Processor {
         // put profile inputs into a local map
         HashMap<String, String> dataInputs = new HashMap<String, String>();
         for (ProfileInput input : data.getInputs()) {
-            Map<String, String> attrs = input.getAttributes();
-            for (Map.Entry<String, String> entry : attrs.entrySet()) {
-                dataInputs.put(entry.getKey(), entry.getValue());
+            for (ProfileAttribute attr: input.getAttrs()) {
+                dataInputs.put(attr.getName(), attr.getValue());
             }
         }
 
